'use strict';

var 
    chalk = require('chalk')
;

module.exports = {
    help: {
        alias: 'h',
        type: 'boolean',
        desc: chalk.gray(
            'Show this help.'
        )
    },
    version: {
        type: 'boolean',
        desc: chalk.gray(
            'Print the huddler version.'
        )
    },
    taskfile: {
        type: 'string',
        requiresArg: true,
        desc: chalk.gray(
            'Manually set path of taskfile. Useful if you have multiple taskfiles. ' +
            'This will set the CWD to the taskfile directory as well.'
        )
    },
    config: {
        type: 'string',
        requiresArg: true,
        desc: chalk.gray(
            'Manually set path of Huddler config file.'
        )
    },
    list: {
        alias: 'l',
        type: 'boolean',
        desc: chalk.gray(
            'Print the task dependency tree for the loaded taskfile.'
        )
    },
    depth: {
        alias: 'd',
        type: 'number',
        requiresArg: true,
        desc: chalk.gray(
            'Specify the depth of the task dependency tree.'
        )
    },
    simple: {
        alias: 's',
        type: 'boolean',
        desc: chalk.gray(
            'Print a plaintext list of tasks for the loaded taskfile.'
        )
    },
    json: {
        alias: 'o',
        desc: chalk.gray(
            'Print the task dependency tree, ' +
            'in JSON format, for the loaded taskfile.'
        )
    },
    color: {
        alias: 'c',
        type: 'boolean',
        desc: chalk.gray(
            'Will force huddler and gulp plugins to display colors, ' +
            'even when no color support is detected.'
        )
    },
    silent: {
        type: 'boolean',
        desc: chalk.gray(
            'Suppress all huddler logging.'
        )
    },
    continue: {
        type: 'boolean',
        desc: chalk.gray(
            'Continue execution of tasks upon failure.'
        )
    },
    verbosity: {
        alias: 'v',
        count: true,
        desc: chalk.gray(
            'Set the loglevel. -v for least verbose and -vvvv for most verbose. ' +
            '-vvv is default.'
        )
    }
};
