'use strict';

var
    fs = require('fs'),
    tildify = require('tildify')
;

function isString(value) {
    return typeof value === 'string';
}

module.exports = function(gulpInst, config, cb) {
    var tree = gulpInst.tree({ deep: true });
    
    if (config.description && isString(config.description)) {
        tree.label = config.description;
    } else {
        tree.label = 'Tasks for ' + tildify(config.taskfile);
    }

    var output = JSON.stringify(tree, null, '    ');
    
    if (isString(config.json)) {
        fs.writeFile(config.json, output, 'utf-8', cb);
    } else {
        console.log(output);
        cb();
    }
};