'use strict';

var
    log = require('gulplog'),
    chalk = require('chalk'),
    tildify = require('tildify')
;

module.exports = function(huddler, config, cb) {
    var tasks = config.tasks;
    var toRun = tasks.length ? tasks : ['default'];
    
    try {
        log.info('Using taskfile', chalk.magenta(tildify(config.taskfile)));
        huddler.parallel(toRun)(cb);
    } catch (err) {
//        log.error(chalk.red(err.message));
//        log.error('To list available tasks, try running: gulp --tasks');
        return cb(err);
    }
    
    cb();
};
