'use strict';

function filterBundles(bundles, filter) {
    if (!filter || '*' === filter) {
        filter = ['*'];
    } else if (!Array.isArray(filter)) {
        filter = [filter];
    }
    
    if (filter.length >= 1 && filter.indexOf('*') !== undefined) {
        return bundles;
    }
    
    var results = new Map();
    
    for (var i = 0; i < filter.length; i++) {
        let name = filter[i];
        if (!bundles.has(name)) {
            throw new Error('Bundle "' + name + '" not found!');
        }
        results.set(name, bundles.get(name));
    }
    
    return results;
};

module.exports = filterBundles;