'use strict';

module.exports = {
    // global
    cwd: {
        type: 'string',
        default: process.cwd
    },
    sourcemaps: {
        type: 'boolean',
        default: false
    },
    bundles: {
        type: ['object', 'array'],
        default: []
    },
    task_path: {
        type: 'string',
        default: 'Resources/private/tasks.js'
    },
    src_dir: {
        type: 'string',
        default: 'src'
    },
    merge: {
        type: 'string',
        default: 'parallel'
    },
    
    // webDir
    mode: {
        type: 'number',
        default: function (file) {
            return file.stat ? file.stat.mode : null;
        }
    },
    web_mode: {
        type: 'number'
    },
    overwrite: {
        type: 'boolean',
        default: true
    },
    flag: {
        type: 'string',
        default: function (file) {
            var overwrite = this.get('overwrite', file);
            return (overwrite ? 'w' : 'wx');
        }
    },
    tracker: {
        type: 'string',
        default: 'assets.json'
    },
    web_dir: {
        type: 'string',
        default: 'web'
    },
    sub_dir: {
        type: 'string',
    },
    targets: {
        type: (value) => {
            if (Array.isArray(value)) {
                return value.reduce((result, val) => {
                    if (typeof val !== 'string') {
                        throw new Error('Expected a string');
                    }
                    result[val] = val;
                    return result;
                }, {});
            }
            return typeof value === 'object' ? value : null;
        },
        default: ['scripts', 'styles', 'fonts', 'images']
    },
    rename: {
        type: 'boolean',
        default: true
    },
    symlink: {
        type: 'boolean',
        default: true
    },
    relative: {
        type: 'boolean',
        default: false
    }
};