'use-strict';

var _running = [];

exports.track = function(name, fn)
{
    if (typeof name === 'function') {
        fn = name;
        name = fn.displayName || fn.name;
    }

    if (typeof fn === 'function') {
        name = name || fn.displayName || fn.name;
        
        function wrapper () {
            _running.push(name);
            
            try {
                return fn.apply(null, arguments);
            } catch (err) {
                throw err;
            } finally {
                _running.pop();
            }
        };
        
        wrapper.displayName = name;
        
        return wrapper;
    }

    return fn;
};

exports.current = function()
{
    return _running[_running.length - 1];
};

